package com.unipi.talepis.softengandroid2023_1;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.HashMap;
import java.util.Map;
import java.util.Optional;

@RestController
public class AppController {
    @Autowired
    private MovieRatingRepository movieRatingRepository;
    @GetMapping ("/ratinglist")
    public Iterable<MovieRating> getAllMovies(){
        return movieRatingRepository.findAll();
    }

    @GetMapping("/find/{id}")
    public MovieRating findById(@PathVariable Integer id){
        Optional<MovieRating> movieRatingOptional = movieRatingRepository.findById(id);
        if (movieRatingOptional.isPresent()){
            return movieRatingOptional.get();
        } else return new MovieRating();
    }
    @PutMapping("/updateMovieRating")
    public Map<String,String> updateMovieRating(@RequestBody Map<String,String> body){
        Optional<MovieRating> movieRatingOptional =
                movieRatingRepository.findById(Integer.parseInt(body.get("id")));
        if (movieRatingOptional.isPresent()){
            MovieRating movieRating = movieRatingOptional.get();
            movieRating.setTitle(body.get("title"));
            movieRating.setYear(Integer.parseInt(body.get("year")));
            movieRating.setRating(Float.parseFloat(body.get("rating")));
            movieRating.setDirector(body.get("director"));
            movieRatingRepository.save(movieRating);
            return new HashMap<String,String>(){{put("Message","Movie Rating updated successfully");}};
        }
        HashMap<String,String> temp = new HashMap<>();
        temp.put("Message","Id not found");
        return temp;
    }
    @PostMapping("/newRating")
    public MovieRating addMovieRating(@RequestBody Map<String,String> body){
        MovieRating movieRating = new MovieRating();
        movieRating.setTitle(body.get("title"));
        movieRating.setYear(Integer.parseInt(body.get("year")));
        movieRating.setRating(Float.parseFloat(body.get("rating")));
        movieRating.setDirector(body.get("director"));
        return movieRatingRepository.save(movieRating);
    }
}
